diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index ca32d1b08fb..82f0f61bc80 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -33,11 +33,18 @@
 #define MAX_PROPS 164
 struct JoystickGenericImpl;
 
-typedef void joy_polldev_handler(IDirectInputDevice8W *iface);
+struct unix_joystick;
+
+struct unix_joystick_vtbl
+{
+    void (CDECL *poll)(struct unix_joystick *ptr);
+};
 
 typedef struct JoystickGenericImpl
 {
     struct IDirectInputDeviceImpl base;
+    const struct unix_joystick_vtbl *unix_funcs;
+    struct unix_joystick *unix_ptr;
 
     ObjProps    props[MAX_PROPS];
     DIDEVCAPS   devcaps;
@@ -46,8 +53,6 @@ typedef struct JoystickGenericImpl
     int         device_axis_count;      /* Total number of axes in the device */
     int        *axis_map;               /* User axes remapping */
     LONG        deadzone;               /* Default dead-zone */
-
-    joy_polldev_handler *joy_polldev;
 } JoystickGenericImpl;
 
 LONG joystick_map_axis(ObjProps *props, int val) DECLSPEC_HIDDEN;
-- 
2.28.0

>From 065b717c9a582ce32de2fab340114dcf302e0f0c Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 22:45:21 +0200
Subject: [PATCH 15/39] dinput: Use the unix vtable for Acquire/Unacquire.

---
 dlls/dinput/joystick.c            | 27 ++++++++++++
 dlls/dinput/joystick_linux.c      | 29 +++++--------
 dlls/dinput/joystick_linuxinput.c | 68 ++++++++++++++-----------------
 dlls/dinput/joystick_osx.c        |  2 +
 dlls/dinput/joystick_private.h    |  7 ++++
 5 files changed, 78 insertions(+), 55 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 1bb7ed95180..f6f50896700 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -472,6 +472,33 @@ HRESULT WINAPI JoystickWGenericImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REF
     return DI_OK;
 }
 
+HRESULT WINAPI JoystickWGenericImpl_Acquire(LPDIRECTINPUTDEVICE8W iface)
+{
+    JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
+    HRESULT hr;
+
+    TRACE("(%p)\n", This);
+
+    if ((hr = IDirectInputDevice2WImpl_Acquire(iface)) != DI_OK) return hr;
+    if (!This->unix_funcs->acquire) return hr;
+    if (SUCCEEDED(hr = This->unix_funcs->acquire(This->unix_ptr))) return hr;
+    IDirectInputDevice2WImpl_Unacquire(iface);
+    return hr;
+}
+
+HRESULT WINAPI JoystickWGenericImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface)
+{
+    JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
+    HRESULT hr;
+
+    TRACE("(%p)\n", This);
+
+    if ((hr = IDirectInputDevice2WImpl_Unacquire(iface)) != DI_OK) return hr;
+    IDirectInputDevice8_SendForceFeedbackCommand(iface, DISFFC_RESET);
+    if (!This->unix_funcs->unacquire) return hr;
+    return This->unix_funcs->unacquire(This->unix_ptr);
+}
+
 #define DEBUG_TYPE(x) case (x): str = #x; break
 void _dump_DIDEVCAPS(const DIDEVCAPS *lpDIDevCaps)
 {
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 8d0500ba035..3301e77d08b 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -135,8 +135,13 @@ static struct JoyDev *joystick_devices;
 
 static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
 
+static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr);
+static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
+
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
+    unix_joystick_acquire,
+    unix_joystick_unacquire,
     unix_joystick_poll,
 };
 
@@ -604,17 +609,12 @@ const struct dinput_device joystick_linux_device = {
 /******************************************************************************
   *     Acquire : gets exclusive control of the joystick
   */
-static HRESULT WINAPI JoystickLinuxWImpl_Acquire(LPDIRECTINPUTDEVICE8W iface)
+static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr)
 {
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-    HRESULT res;
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
 
     TRACE("(%p)\n",This);
 
-    res = IDirectInputDevice2WImpl_Acquire(iface);
-    if (res != DI_OK)
-        return res;
-
     /* open the joystick device */
     if (This->joyfd==-1) {
         TRACE("opening joystick device %s\n", This->joydev->device);
@@ -622,7 +622,6 @@ static HRESULT WINAPI JoystickLinuxWImpl_Acquire(LPDIRECTINPUTDEVICE8W iface)
         This->joyfd = open(This->joydev->device, O_RDONLY);
         if (This->joyfd==-1) {
             ERR("open(%s) failed: %s\n", This->joydev->device, strerror(errno));
-            IDirectInputDevice2WImpl_Unacquire(iface);
             return DIERR_NOTFOUND;
         }
     }
@@ -633,18 +632,12 @@ static HRESULT WINAPI JoystickLinuxWImpl_Acquire(LPDIRECTINPUTDEVICE8W iface)
 /******************************************************************************
   *     Unacquire : frees the joystick
   */
-static HRESULT WINAPI JoystickLinuxWImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface)
+static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr)
 {
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-    HRESULT res;
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
 
     TRACE("(%p)\n",This);
 
-    res = IDirectInputDevice2WImpl_Unacquire(iface);
-
-    if (res != DI_OK)
-        return res;
-
     if (This->joyfd!=-1) {
         TRACE("closing joystick device\n");
         close(This->joyfd);
@@ -740,8 +733,8 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_EnumObjects,
     JoystickWGenericImpl_GetProperty,
     JoystickWGenericImpl_SetProperty,
-    JoystickLinuxWImpl_Acquire,
-    JoystickLinuxWImpl_Unacquire,
+    JoystickWGenericImpl_Acquire,
+    JoystickWGenericImpl_Unacquire,
     JoystickWGenericImpl_GetDeviceState,
     IDirectInputDevice2WImpl_GetDeviceData,
     IDirectInputDevice2WImpl_SetDataFormat,
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index c72b5919f87..62308e615f3 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -89,8 +89,6 @@ HRESULT linuxinput_create_effect(int* fd, REFGUID rguid, struct list *parent_lis
 HRESULT linuxinput_get_info_A(int fd, REFGUID rguid, LPDIEFFECTINFOA info);
 HRESULT linuxinput_get_info_W(int fd, REFGUID rguid, LPDIEFFECTINFOW info);
 
-static HRESULT WINAPI JoystickWImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE8W iface, DWORD dwFlags);
-
 typedef struct JoystickImpl JoystickImpl;
 static const IDirectInputDevice8WVtbl JoystickWvt;
 
@@ -160,8 +158,13 @@ static void fake_current_js_state(JoystickImpl *ji);
 static void find_joydevs(void);
 static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
 
+static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr);
+static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
+
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
+    unix_joystick_acquire,
+    unix_joystick_unacquire,
     unix_joystick_poll,
 };
 
@@ -626,26 +629,18 @@ const struct dinput_device joystick_linuxinput_device = {
 /******************************************************************************
   *     Acquire : gets exclusive control of the joystick
   */
-static HRESULT WINAPI JoystickWImpl_Acquire(LPDIRECTINPUTDEVICE8W iface)
+static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr)
 {
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-    HRESULT res;
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
 
     TRACE("(this=%p)\n",This);
 
-    if ((res = IDirectInputDevice2WImpl_Acquire(iface)) != DI_OK)
-    {
-        WARN("Failed to acquire: %x\n", res);
-        return res;
-    }
-
     if ((This->joyfd = open(This->joydev->device, O_RDWR)) == -1)
     {
         if ((This->joyfd = open(This->joydev->device, O_RDONLY)) == -1)
         {
             /* Couldn't open the device at all */
             ERR("Failed to open device %s: %d %s\n", This->joydev->device, errno, strerror(errno));
-            IDirectInputDevice2WImpl_Unacquire(iface);
             return DIERR_NOTFOUND;
         }
         else
@@ -679,33 +674,32 @@ static HRESULT WINAPI JoystickWImpl_Acquire(LPDIRECTINPUTDEVICE8W iface)
 /******************************************************************************
   *     Unacquire : frees the joystick
   */
-static HRESULT WINAPI JoystickWImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface)
+static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr)
 {
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-    HRESULT res;
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
 
     TRACE("(this=%p)\n",This);
-    res = IDirectInputDevice2WImpl_Unacquire(iface);
-    if (res==DI_OK && This->joyfd!=-1) {
-      struct input_event event;
-
-      /* Stop and unload all effects */
-      JoystickWImpl_SendForceFeedbackCommand(iface, DISFFC_RESET);
-
-      /* Enable autocenter. */
-      event.type = EV_FF;
-      event.code = FF_AUTOCENTER;
-      /* TODO: Read autocenter strength before disabling it, and use it here
-       * instead of 0xFFFF (maximum strength).
-       */
-      event.value = 0xFFFF;
-      if (write(This->joyfd, &event, sizeof(event)) == -1)
-        ERR("Failed to set autocenter to %04x: %d %s\n", event.value, errno, strerror(errno));
-
-      close(This->joyfd);
-      This->joyfd = -1;
+
+    if (This->joyfd != -1)
+    {
+        struct input_event event;
+
+        /* Enable autocenter. */
+        event.type = EV_FF;
+        event.code = FF_AUTOCENTER;
+        /* TODO: Read autocenter strength before disabling it, and use it here
+         * instead of 0xFFFF (maximum strength).
+         */
+        event.value = 0xFFFF;
+        if (write(This->joyfd, &event, sizeof(event)) == -1)
+            ERR("Failed to set autocenter to %04x: %d %s\n", event.value, errno, strerror(errno));
+
+        close(This->joyfd);
+        This->joyfd = -1;
+        return DI_OK;
     }
-    return res;
+
+    return DI_NOEFFECT;
 }
 
 /* 
@@ -1197,8 +1191,8 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_EnumObjects,
     JoystickWImpl_GetProperty,
     JoystickWImpl_SetProperty,
-    JoystickWImpl_Acquire,
-    JoystickWImpl_Unacquire,
+    JoystickWGenericImpl_Acquire,
+    JoystickWGenericImpl_Unacquire,
     JoystickWGenericImpl_GetDeviceState,
     IDirectInputDevice2WImpl_GetDeviceData,
     IDirectInputDevice2WImpl_SetDataFormat,
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index c0ce7547aa9..87111669633 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -945,6 +945,8 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
+    NULL,
+    NULL,
     unix_joystick_poll,
 };
 
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 82f0f61bc80..e7e64e26cd1 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -37,6 +37,9 @@ struct unix_joystick;
 
 struct unix_joystick_vtbl
 {
+    HRESULT (CDECL *acquire)(struct unix_joystick *ptr);
+    HRESULT (CDECL *unacquire)(struct unix_joystick *ptr);
+
     void (CDECL *poll)(struct unix_joystick *ptr);
 };
 
@@ -73,6 +76,10 @@ void _dump_DIDEVCAPS(const DIDEVCAPS *lpDIDevCaps) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIPROPHEADER ph) DECLSPEC_HIDDEN;
 
+HRESULT WINAPI JoystickWGenericImpl_Acquire(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
+
+HRESULT WINAPI JoystickWGenericImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
+
 HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface, DWORD len, LPVOID ptr) DECLSPEC_HIDDEN;
-- 
2.28.0

>From de6d92b932833a9584689f78481d0a0941522092 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 22:47:50 +0200
Subject: [PATCH 16/39] dinput: Use the unix vtable for SetProperty.

---
 dlls/dinput/joystick.c            |  33 ++++++++
 dlls/dinput/joystick_linux.c      |   2 +
 dlls/dinput/joystick_linuxinput.c | 120 ++++++++----------------------
 dlls/dinput/joystick_osx.c        |  36 +++------
 dlls/dinput/joystick_private.h    |   6 ++
 5 files changed, 85 insertions(+), 112 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index f6f50896700..011018b2a4f 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -343,6 +343,7 @@ HRESULT WINAPI JoystickWGenericImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REF
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
     DWORD i;
     ObjProps remap_props;
+    HRESULT hr;
 
     TRACE("(%p,%s,%p)\n",This,debugstr_guid(rguid),ph);
 
@@ -464,6 +465,22 @@ HRESULT WINAPI JoystickWGenericImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REF
           FIXME("DIPROP_CALIBRATIONMODE(%d)\n", pd->dwData);
           break;
         }
+        case (DWORD_PTR)DIPROP_AUTOCENTER:
+        {
+            LPCDIPROPDWORD pd = (LPCDIPROPDWORD)ph;
+            if (!This->unix_funcs->ff_set_autocenter) return DIERR_UNSUPPORTED;
+            if (FAILED(hr = This->unix_funcs->ff_set_autocenter(This->unix_ptr, pd->dwData))) return hr;
+            This->ff_autocenter = pd->dwData;
+            return DI_OK;
+        }
+        case (DWORD_PTR)DIPROP_FFGAIN:
+        {
+            LPCDIPROPDWORD pd = (LPCDIPROPDWORD)ph;
+            if (!This->unix_funcs->ff_set_gain) return DIERR_UNSUPPORTED;
+            if (FAILED(hr = This->unix_funcs->ff_set_gain(This->unix_ptr, pd->dwData))) return hr;
+            This->ff_gain = pd->dwData;
+            return DI_OK;
+        }
         default:
             return IDirectInputDevice2WImpl_SetProperty(iface, rguid, ph);
         }
@@ -698,6 +715,22 @@ HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
             TRACE("guidandpath(%s, %s): returning fake path\n", debugstr_guid(&pd->guidClass), debugstr_w(pd->wszPath));
             return DI_OK;
         }
+        case (DWORD_PTR)DIPROP_AUTOCENTER:
+        {
+            LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
+            if (!This->unix_funcs->ff_set_autocenter) return DIERR_UNSUPPORTED;
+            pd->dwData = This->ff_autocenter;
+            TRACE("autocenter(%d)\n", pd->dwData);
+            return DI_OK;
+        }
+        case (DWORD_PTR)DIPROP_FFGAIN:
+        {
+            LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
+            if (!This->unix_funcs->ff_set_gain) return DIERR_UNSUPPORTED;
+            pd->dwData = This->ff_gain;
+            TRACE("ffgain(%d)\n", pd->dwData);
+            return DI_OK;
+        }
         default:
             return IDirectInputDevice2WImpl_GetProperty(iface, rguid, pdiph);
         }
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 3301e77d08b..f1ca6451428 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -142,6 +142,8 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     unix_joystick_acquire,
     unix_joystick_unacquire,
+    NULL,
+    NULL,
     unix_joystick_poll,
 };
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 62308e615f3..eeb4d9bd220 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -161,10 +161,15 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
 
+static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value);
+static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD value);
+
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     unix_joystick_acquire,
     unix_joystick_unacquire,
+    unix_joystick_ff_set_autocenter,
+    unix_joystick_ff_set_gain,
     unix_joystick_poll,
 };
 
@@ -463,6 +468,8 @@ static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsig
        enabled. */
     newDevice->ff_autocenter = 1;
     newDevice->ff_gain = 0xFFFF;
+    newDevice->generic.ff_autocenter = DIPROPAUTOCENTER_ON;
+    newDevice->generic.ff_gain = 10000;
 
     /* Count number of available axes - supported Axis & POVs */
     for (i = 0; i < ABS_MAX; i++)
@@ -702,6 +709,29 @@ static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr)
     return DI_NOEFFECT;
 }
 
+static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value)
+{
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    This->ff_autocenter = value == DIPROPAUTOCENTER_ON;
+    return DI_OK;
+}
+
+static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD value)
+{
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    struct input_event event;
+
+    This->ff_gain = MulDiv(value, 0xFFFF, 10000);
+    if (!This->generic.base.acquired) return DI_OK;
+
+    event.type = EV_FF;
+    event.code = FF_GAIN;
+    event.value = This->ff_gain;
+    if (write(This->joyfd, &event, sizeof(event)) == -1)
+        ERR("Failed to set gain (%i): %d %s\n", This->ff_gain, errno, strerror(errno));
+    return DI_OK;
+}
+
 /* 
  * set the current state of the js device as it would be with the middle
  * values on the axes
@@ -834,92 +864,6 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
     }
 }
 
-/******************************************************************************
-  *     SetProperty : change input device properties
-  */
-static HRESULT WINAPI JoystickWImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIPROPHEADER ph)
-{
-  JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-
-  if (!ph) {
-    WARN("invalid argument\n");
-    return DIERR_INVALIDPARAM;
-  }
-
-  TRACE("(this=%p,%s,%p)\n",This,debugstr_guid(rguid),ph);
-  TRACE("ph.dwSize = %d, ph.dwHeaderSize =%d, ph.dwObj = %d, ph.dwHow= %d\n",
-        ph->dwSize, ph->dwHeaderSize, ph->dwObj, ph->dwHow);
-
-  if (IS_DIPROP(rguid)) {
-    switch (LOWORD(rguid)) {
-    case (DWORD_PTR)DIPROP_AUTOCENTER: {
-      LPCDIPROPDWORD pd = (LPCDIPROPDWORD)ph;
-
-      TRACE("autocenter(%d)\n", pd->dwData);
-      This->ff_autocenter = pd->dwData == DIPROPAUTOCENTER_ON;
-
-      break;
-    }
-    case (DWORD_PTR)DIPROP_FFGAIN: {
-      LPCDIPROPDWORD pd = (LPCDIPROPDWORD)ph;
-
-      TRACE("DIPROP_FFGAIN(%d)\n", pd->dwData);
-      This->ff_gain = MulDiv(pd->dwData, 0xFFFF, 10000);
-      if (This->generic.base.acquired) {
-        /* Update immediately. */
-        struct input_event event;
-
-        event.type = EV_FF;
-        event.code = FF_GAIN;
-        event.value = This->ff_gain;
-        if (write(This->joyfd, &event, sizeof(event)) == -1)
-          ERR("Failed to set gain (%i): %d %s\n", This->ff_gain, errno, strerror(errno));
-      }
-      break;
-    }
-    default:
-      return JoystickWGenericImpl_SetProperty(iface, rguid, ph);
-    }
-  }
-  return DI_OK;
-}
-
-/******************************************************************************
-  *     GetProperty : get input device properties
-  */
-static HRESULT WINAPI JoystickWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPDIPROPHEADER pdiph)
-{
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-
-    TRACE("(%p)->(%s,%p)\n", This, debugstr_guid(rguid), pdiph);
-    _dump_DIPROPHEADER(pdiph);
-
-    if (!IS_DIPROP(rguid)) return DI_OK;
-
-    switch (LOWORD(rguid)) {
-    case (DWORD_PTR) DIPROP_AUTOCENTER:
-    {
-        LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
-
-        pd->dwData = This->ff_autocenter ? DIPROPAUTOCENTER_ON : DIPROPAUTOCENTER_OFF;
-        TRACE("autocenter(%d)\n", pd->dwData);
-        break;
-    }
-    case (DWORD_PTR) DIPROP_FFGAIN:
-    {
-        LPDIPROPDWORD pd = (LPDIPROPDWORD)pdiph;
-
-        pd->dwData = MulDiv(This->ff_gain, 10000, 0xFFFF);
-        TRACE("DIPROP_FFGAIN(%d)\n", pd->dwData);
-        break;
-    }
-    default:
-        return JoystickWGenericImpl_GetProperty(iface, rguid, pdiph);
-    }
-
-    return DI_OK;
-}
-
 /****************************************************************************** 
   *	CreateEffect - Create a new FF effect with the specified params
   */
@@ -1189,8 +1133,8 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_Release,
     JoystickWGenericImpl_GetCapabilities,
     IDirectInputDevice2WImpl_EnumObjects,
-    JoystickWImpl_GetProperty,
-    JoystickWImpl_SetProperty,
+    JoystickWGenericImpl_GetProperty,
+    JoystickWGenericImpl_SetProperty,
     JoystickWGenericImpl_Acquire,
     JoystickWGenericImpl_Unacquire,
     JoystickWGenericImpl_GetDeviceState,
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 87111669633..f129b666b2f 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -943,10 +943,15 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
     }
 }
 
+static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value);
+static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD value);
+
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     NULL,
     NULL,
+    unix_joystick_ff_set_autocenter,
+    unix_joystick_ff_set_gain,
     unix_joystick_poll,
 };
 
@@ -1292,49 +1297,32 @@ static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDir
     return DIERR_DEVICENOTREG;
 }
 
-static HRESULT osx_set_autocenter(JoystickImpl *This,
-        const DIPROPDWORD *header)
+static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value)
 {
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
     UInt32 v;
     HRESULT hr;
     if(!This->ff)
         return DIERR_UNSUPPORTED;
-    v = header->dwData;
+    v = value;
     hr = osx_to_win32_hresult(FFDeviceSetForceFeedbackProperty(This->ff, FFPROP_AUTOCENTER, &v));
     TRACE("returning: %08x\n", hr);
     return hr;
 }
 
-static HRESULT osx_set_ffgain(JoystickImpl *This, const DIPROPDWORD *header)
+static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD value)
 {
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
     UInt32 v;
     HRESULT hr;
     if(!This->ff)
         return DIERR_UNSUPPORTED;
-    v = header->dwData;
+    v = value;
     hr = osx_to_win32_hresult(FFDeviceSetForceFeedbackProperty(This->ff, FFPROP_FFGAIN, &v));
     TRACE("returning: %08x\n", hr);
     return hr;
 }
 
-static HRESULT WINAPI JoystickWImpl_SetProperty(IDirectInputDevice8W *iface,
-        const GUID *prop, const DIPROPHEADER *header)
-{
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-
-    TRACE("%p %s %p\n", This, debugstr_guid(prop), header);
-
-    switch(LOWORD(prop))
-    {
-    case (DWORD_PTR)DIPROP_AUTOCENTER:
-        return osx_set_autocenter(This, (const DIPROPDWORD *)header);
-    case (DWORD_PTR)DIPROP_FFGAIN:
-        return osx_set_ffgain(This, (const DIPROPDWORD *)header);
-    }
-
-    return JoystickWGenericImpl_SetProperty(iface, prop, header);
-}
-
 static CFUUIDRef effect_win_to_mac(const GUID *effect)
 {
 #define DO_MAP(X) \
@@ -1435,7 +1423,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     JoystickWGenericImpl_GetCapabilities,
     IDirectInputDevice2WImpl_EnumObjects,
     JoystickWGenericImpl_GetProperty,
-    JoystickWImpl_SetProperty,
+    JoystickWGenericImpl_SetProperty,
     IDirectInputDevice2WImpl_Acquire,
     IDirectInputDevice2WImpl_Unacquire,
     JoystickWGenericImpl_GetDeviceState,
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index e7e64e26cd1..c7d1669fe1f 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -40,6 +40,9 @@ struct unix_joystick_vtbl
     HRESULT (CDECL *acquire)(struct unix_joystick *ptr);
     HRESULT (CDECL *unacquire)(struct unix_joystick *ptr);
 
+    HRESULT (CDECL *ff_set_autocenter)(struct unix_joystick *ptr, DWORD value);
+    HRESULT (CDECL *ff_set_gain)(struct unix_joystick *ptr, DWORD value);
+
     void (CDECL *poll)(struct unix_joystick *ptr);
 };
 
@@ -56,6 +59,9 @@ typedef struct JoystickGenericImpl
     int         device_axis_count;      /* Total number of axes in the device */
     int        *axis_map;               /* User axes remapping */
     LONG        deadzone;               /* Default dead-zone */
+
+    DWORD ff_autocenter;
+    DWORD ff_gain;
 } JoystickGenericImpl;
 
 LONG joystick_map_axis(ObjProps *props, int val) DECLSPEC_HIDDEN;
-- 
2.28.0

>From 8544b781fa8adbc90f0dc50be21d808ad1c5df1e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 22:50:24 +0200
Subject: [PATCH 17/39] dinput: Use the unix vtable for CreateEffect.

---
 dlls/dinput/joystick.c            | 40 ++++++++++++++
 dlls/dinput/joystick_linux.c      |  1 +
 dlls/dinput/joystick_linuxinput.c | 91 ++++++++-----------------------
 dlls/dinput/joystick_osx.c        | 30 +++++-----
 dlls/dinput/joystick_private.h    |  9 +++
 5 files changed, 86 insertions(+), 85 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 011018b2a4f..d80dd7d5caf 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -739,6 +739,46 @@ HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
     return DI_OK;
 }
 
+HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIEFFECT lpeff,
+        LPDIRECTINPUTEFFECT *ppdef, LPUNKNOWN pUnkOuter)
+{
+    JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
+    effect_list_item *item = NULL;
+    HRESULT hr;
+
+    TRACE("(this=%p,%p,%p,%p,%p)\n", This, rguid, lpeff, ppdef, pUnkOuter);
+
+    if (!ppdef) return E_POINTER;
+    *ppdef = NULL;
+
+    if (!This->unix_funcs->create_effect) return DIERR_UNSUPPORTED;
+    if (!(item = HeapAlloc(GetProcessHeap(), 0, sizeof(*item)))) return DIERR_OUTOFMEMORY;
+    if (FAILED(hr = This->unix_funcs->create_effect(This->unix_ptr, rguid, lpeff, &item->entry, &item->ref)))
+    {
+        HeapFree(GetProcessHeap(), 0, item);
+        return hr;
+    }
+    list_add_tail(&This->ff_effects, &item->entry);
+    *ppdef = item->ref;
+    if (pUnkOuter != NULL) FIXME("Interface aggregation not implemented.\n");
+    return DI_OK;
+}
+
+HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE8W iface,
+        LPDIENUMCREATEDEFFECTOBJECTSCALLBACK lpCallback, LPVOID pvRef, DWORD dwFlags)
+{
+    JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
+    effect_list_item *itr, *ptr;
+
+    TRACE("(this=%p,%p,%p,%d)\n", This, lpCallback, pvRef, dwFlags);
+
+    if (!lpCallback) return DIERR_INVALIDPARAM;
+    if (dwFlags != 0) FIXME("Flags specified, but no flags exist yet (DX9)!\n");
+    LIST_FOR_EACH_ENTRY_SAFE(itr, ptr, &This->ff_effects, effect_list_item, entry)
+        (*lpCallback)(itr->ref, pvRef);
+    return DI_OK;
+}
+
 HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index f1ca6451428..615d9432718 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -144,6 +144,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     unix_joystick_unacquire,
     NULL,
     NULL,
+    NULL,
     unix_joystick_poll,
 };
 
